// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
// Check the contents of files [1-5].ds created with gtibuild in testgtibuild
//
// Eduardo Ojero, June 2004
//
// This code replaces the checkgtibuild perl code
//
// $Id: checkgtibuild.cc,v 1.1 2004/06/07 13:13:48 eojero Exp $
//

#include <Dal.h>
#include <cassert>
#include <iostream>
#include <string>
#include <metatask.h>


int main (){
    
  std::vector<std::string> dataset; 
  dataset.push_back("1.ds");
  dataset.push_back("2.ds");
  dataset.push_back("3.ds");
  dataset.push_back("4.ds");
  dataset.push_back("5.ds");
  
  for ( unsigned k = 0 ; k < dataset.size() ; k++ ) {

     DataSet *ds = dataSetServer->open(dataset[k], Dal::Read);

     Table *tab = ds->table("STDGTI");

     ColumnData *start = tab->column("START")->data();
     ColumnData *stop  = tab->column("STOP")->data();

     real64 *vstart = start->real64Data();
     real64 *vstop  = stop->real64Data();
 
     if ( k == 0){

        assert(vstart[0] == 0);
        assert(vstart[1] == 2000);
        assert(vstop[0]  == 1000);
        assert(vstop[1]  == 3000);
     }

     if (k == 1) {

        assert(vstart[0] == 0);
        assert(vstart[1] == 2000);
        assert(vstop[0]  == 1000);
        assert(vstop[1]  == 3000);

     }

     if (k == 2) {
        assert(vstart[0] == 200);
        assert(vstop[0]  > 1e20);
     }

     if (k == 3) {
        assert(vstart[0] == 0);
        assert(vstart[1] == 200);
        assert(vstop[0]  == 100);
        assert(vstop[1]  > 1e20);
     }
 
     if (k == 4) {
        assert(vstart[0] == 0);
        assert(vstart[1] == 110);
        assert(vstart[2] == 170);
        assert(vstart[3] == 230);
        assert(vstop[0]  == 90);
        assert(vstop[1]  == 150);
        assert(vstop[2]  == 210);
        assert(vstop[3]  == 270);
        assert(vstop[16] > 1e20);
     }
  delete start;
  delete stop;
  dataSetServer->close(ds);
  }
}
