#! /usr/local/bin/perl -w
# ESA (C) 2000-2018 
#
# This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
#
#    SAS is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    SAS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#
# $Id: checkgtibuild.pl,v 1.1 2004/06/07 13:12:17 eojero Exp $
#
use strict;
use DAL;

my ($ds, $tab, $start, $stop);

sub assert {
  die unless (shift);
}

sub openset {
  my $name = shift or die;
  print "$name\n";
  $ds = new DAL::dataset(name => $name, accessmode => $DAL::READ) or die;
  $tab = $ds->table(name => "STDGTI");
  $start = $tab->column(name => "START")->data();
  $stop = $tab->column(name => "STOP")->data();
}

openset("1.ds");
assert($start->value(0) == 0);
assert($start->value(1) == 2000);
assert($stop->value(0) == 1000);
assert($stop->value(1) == 3000);
$ds->release();

openset("2.ds");
assert($start->value(0) == 0);
assert($start->value(1) == 2000);
assert($stop->value(0) == 1000);
assert($stop->value(1) == 3000);
$ds->release();

openset("3.ds");
assert($start->value(0) == 200);
assert($stop->value(0) > 1e20);
$ds->release();

openset("4.ds");
assert($start->value(0) == 0);
assert($start->value(1) == 200);
assert($stop->value(0) == 100);
assert($stop->value(1) > 1e20);
$ds->release();

openset("5.ds");
assert($start->value(0) == 0);
assert($start->value(1) == 110);
assert($start->value(2) == 170);
assert($start->value(3) == 230);
assert($stop->value(0) == 90);
assert($stop->value(1) == 150);
assert($stop->value(2) == 210);
assert($stop->value(3) == 270);
assert($stop->value(16) > 1e20);
$ds->release();



